//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  5
#property indicator_color1   Orange
#property indicator_width1   2

//
//
//
//
//

extern double Length      = 32;
extern int    Price       = PRICE_TYPICAL;
extern int    AdaptPeriod = 15;
double rsi[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi);
   Length = MathMax(Length ,1);
   IndicatorShortName("Adaptive RSX ("+DoubleToStr(Length,2)+","+AdaptPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][13];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);


   //
   //
   //
   //
   //
   //

         for(i=limit, r=Bars-i-1; i>=0; i--, r++)
         {
            wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
               double dev = iStdDev(NULL,0,AdaptPeriod,0,MODE_SMA,Price,i);
               double avg = iSma(dev,AdaptPeriod,i,0);
               if (dev!=0) 
                      double period = Length*avg/dev;
               else          period = Length; 
               double Kg = (3.0)/(2.0+period); 
               double Hg = 1.0-Kg;
            if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

            //
            //
            //
            //
            //
      
            double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
            double moa = MathAbs(mom);
            for (int k=0; k<3; k++)
            {
               int kk = k*2;
                  wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
                  wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
                  wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
                  wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
            }
            if (moa != 0)
                 rsi[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
            else rsi[i] = 0;
         }
         return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}